/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;

import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_AntiarrhythmicAgents;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_AntiarrhythmicAgents;

/**
 * This class represents AntiarrhythmicAgents_CID3762
 */
public class AntiarrhythmicAgents_CID3762 {
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;

	/**
	 * Instantiates a new AntiarrhythmicAgents_CID3762 Template
	 */
	public AntiarrhythmicAgents_CID3762() {

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * 
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning() {
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * 
	 * @return String value for Code Value.
	 */
	public String getCodeValue() {
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * 
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() {
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * 
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() {
		return strSNOMEDCTID;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * 
	 * @param enumAntiarrhythmicAgents
	 *            Object of EnumCM_AntiarrhythmicAgents represents Code Meaning.
	 */
	private void setCodeValue(
			EnumCM_AntiarrhythmicAgents enumAntiarrhythmicAgents) {
		switch (enumAntiarrhythmicAgents) {
		case CLASS_ONE_ANTIARRHYTHMIC_AGENT:
			this.strCodeValue = EnumCV_AntiarrhythmicAgents.CLASS_ONE_ANTIARRHYTHMIC_AGENT_F_6181B
					.getValue();
			break;
		case CLASS_TWO_ANTIARRHYTHMIC_AGENT:
			this.strCodeValue = EnumCV_AntiarrhythmicAgents.CLASS_TWO_ANTIARRHYTHMIC_AGENT_F_61861
					.getValue();
			break;
		case CLASS_THREE_ANTIARRHYTHMIC_AGENT:
			this.strCodeValue = EnumCV_AntiarrhythmicAgents.CLASS_THREE_ANTIARRHYTHMIC_AGENT_F_61995
					.getValue();
			break;
		case CLASS_FOUR_ANTIARRHYTHMIC_AGENT:
			this.strCodeValue = EnumCV_AntiarrhythmicAgents.CLASS_FOUR_ANTIARRHYTHMIC_AGENT_F_618AE
					.getValue();
			break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * 
	 * @param enumAntiarrhythmicAgents
	 *            Object of EnumCM_AntiarrhythmicAgents represents Code Meaning.
	 */
	private void setSNOMEDCTID(
			EnumCM_AntiarrhythmicAgents enumAntiarrhythmicAgents) {
		switch (enumAntiarrhythmicAgents) {
		case CLASS_ONE_ANTIARRHYTHMIC_AGENT:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.CLASS_ONE_ANTIARRHYTHMIC_AGENT
					.getSNOMEDCTID();
			break;
		case CLASS_TWO_ANTIARRHYTHMIC_AGENT:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.CLASS_TWO_ANTIARRHYTHMIC_AGENT
					.getSNOMEDCTID();
			break;
		case CLASS_THREE_ANTIARRHYTHMIC_AGENT:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.CLASS_THREE_ANTIARRHYTHMIC_AGENT
					.getSNOMEDCTID();
			break;
		case CLASS_FOUR_ANTIARRHYTHMIC_AGENT:
			this.strSNOMEDCTID = EnumDICOMSNOMEDMap.CLASS_FOUR_ANTIARRHYTHMIC_AGENT
					.getSNOMEDCTID();
			break;

		}
	}

	/**
	 * Sets the value for AntiarrhythmicAgents
	 * 
	 * @param enumAntiarrhythmicAgents
	 *            Object of EnumCM_AntiarrhythmicAgents.
	 */
	public void setAntiarrhythmicAgents(
			EnumCM_AntiarrhythmicAgents enumAntiarrhythmicAgents) {
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion
		 * and Code Meaning and sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumAntiarrhythmicAgents.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT
				.getValue();

		/**
		 * set code Value
		 */
		setCodeValue(enumAntiarrhythmicAgents);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumAntiarrhythmicAgents);
	}
}
